import csv
from time import sleep

from data.sig_ref import SIGRef
from providers.sigrefdata.file_download_sig_ref_data_provider import FileDownloadSIGRefDataProvider


class Towers(FileDownloadSIGRefDataProvider):
    """SIG ref data provider for Towers on the Air"""

    POLL_INTERVAL_DAYS = 30
    SIG = "Towers"
    DATA_URL = "https://wwtota.com/servis/generate_csv.php?ref=&filter=all"

    def __init__(self, provider_config):
        super().__init__(self.SIG, provider_config, self.DATA_URL, self.POLL_INTERVAL_DAYS)

    def _http_response_to_data(self, http_response):
        new_data = []
        for row in csv.DictReader(http_response.content.decode("utf-8-sig").splitlines(), delimiter=";"):
            ref_id = row["Ref"]
            new_data.append(SIGRef(sig=self.SIG, id=ref_id, name=row["Nazev"] if "Nazev" in row else None,
                                      ref_type="Tower",
                                      url="https://wwtota.com/seznam/karta_rozhledny.php?ref=" + ref_id,
                                      grid=row["Lokator"] if "Lokator" in row and row["Lokator"] != "" else None,
                                      latitude=float(row["Lat"]) if "Lat" in row and row["Lat"] != "" else None,
                                      longitude=float(row["Lon"]) if "Lon" in row and row["Lon"] != "" else None))

            # Bail out if a stop has been requested, i.e. the program is shutting down - no need to parse the rest of
            # the data in this case
            if self._stop_event.is_set():
                break

            # Very short pause. This will extend the time to handle sig refs by a few seconds but will ensure some time
            # is available for other threads e.g. the web server.
            sleep(0.001)

        return new_data
